Attribute VB_Name = "DNA"
Option Explicit

'boolstack structure used for conditionals
Private Type boolstack
  val(20) As Boolean
  pos As Integer
End Type

Public sysvar(200) As var    ' array of system variables
Public Const stacklim As Integer = 20

Dim currgene As Long 'for *.thisgene
Dim Condst As boolstack 'for the conditions stack

' compiles a list of genes entry points, that is
' the position of each gene's "cond" instruction in
' the dna array
Public Sub makecondlist(n As Integer)
  Dim t As Integer
  Dim k As Integer
  t = 1
  k = 1
  While Not (rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 4)
    If rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 1 Then
      rob(n).condlist(k) = t
      k = k + 1
    End If
    t = t + 1
    If t > UBound(rob(n).DNA()) Then GoTo exitwhile
  Wend
exitwhile:
  rob(n).condlist(k) = 0
  rob(n).genenum = k - 1
End Sub

' creates the array which is copied to the ref* variables
' of any opponent looking at us
Public Sub makeoccurrlist(n As Integer)
  Dim t As Integer, k As Integer
  With rob(n)
    For t = 1 To 12
      .occurr(t) = 0
    Next t
    t = 1
    k = 1
    While Not (.DNA(t).tipo = 4 And .DNA(t).value = 4)
      If .DNA(t).tipo = 0 And .DNA(t).value < 8 And .DNA(t).value > 0 Then
        If .DNA(t + 1).tipo = 2 And .DNA(t + 1).value = 1 Then
          .occurr(.DNA(t).value) = .occurr(.DNA(t).value) + 1
        End If
      End If
      If .DNA(t).value > 500 And .DNA(t).value < 510 Then
        .occurr(8) = .occurr(8) + 1 'eyes
      End If
      If .DNA(t).value = 330 Then
        .occurr(9) = .occurr(9) + 1 'ties
      End If
      If .DNA(t).value = 826 Or .DNA(t).value = 827 Then
        .occurr(10) = .occurr(10) + 1   'poison controls
      End If
      If .DNA(t).value = 824 Or .DNA(t).value = 825 Then
        .occurr(10) = .occurr(11) + 1   'venom controls
      End If
      t = t + 1
      If t > UBound(.DNA()) Then GoTo exitwhile
    Wend
exitwhile:
    
    If n = 11 Then Record_11eyes .occurr(8)
    If n >= 16 And n <= 20 And LeagueMode Then League_Eyefudge n, t
    
    'creates the "ownvars" our own readbacks as versions of the refvars seen by others
    For t = 1 To 8
      .mem(720 + t) = .occurr(t)
    Next t
    .mem(728) = .occurr(8)
    .mem(729) = .occurr(9)
    .mem(730) = .occurr(10)
    .mem(731) = .occurr(11)
  End With
End Sub

' counts total number of conditions used, to calculate
' their energy cost during simulation
Public Sub countconditions(n As Integer)
  Dim t As Integer, k As Integer
  t = 1
  k = 0
  While Not (rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 4)
    If rob(n).DNA(t).tipo = 3 Then k = k + 1
    t = t + 1
  Wend
  rob(n).condnum = k
End Sub

' converts system location to its var name
' for readable dna save
Public Function varname(a As Integer) As String
  Dim t As Integer
  t = 1
  varname = right$(Str$(a), Len(Str$(a)) - 1)
  While sysvar(t).value <> 0
    If sysvar(t).value = a Then varname = "." + sysvar(t).Name
    t = t + 1
  Wend
End Function

Public Function Instrname(a As Integer) As String
   Select Case a
     Case 1
       Instrname = " store"
     Case 3
       Instrname = " add"
     Case 4
       Instrname = " sub"
     Case 5
       Instrname = " mult"
     Case 6
       Instrname = " div"
     Case 7
       Instrname = " rnd"
     Case 8
       Instrname = " inc"
     Case 9
       Instrname = " dec"
     Case 10
       Instrname = " angle"
     Case 11
       Instrname = " dist"
     Case 12
       Instrname = " addstore"
     Case 13
       Instrname = " substore"
     Case 14
       Instrname = " divstore"
     Case 15
       Instrname = " multstore"
     Case 16
       Instrname = " mod"
     Case 17
       Instrname = " ceil"
     Case 18
       Instrname = " floor"
     Case 19
       Instrname = " sqr"
     Case 20
       Instrname = " ^"
     Case 21
       Instrname = " sgn"
     Case 22
       Instrname = " abs"
     Case 23
       Instrname = " dup"
     Case 24
       Instrname = " pyth"
   End Select
End Function

'converts system location to condition for easier printout of condition changes
'in the console
Public Function Condname(a As Integer) As String
  Dim t As Integer
  Select Case a
    Case 1
      Condname = " <"
    Case 2
      Condname = " >"
    Case 3
      Condname = " ="
    Case 4
      Condname = " !="
    Case 5
      Condname = " %="
    Case 6
      Condname = " !%="
    Case 7
      Condname = " ~="
    Case 8
      Condname = " !~="
    Case 9
      Condname = " >="
    Case 10
      Condname = " <="
  End Select
End Function

' measures dna length
Public Function DNALength(n As Integer) As Integer
  Dim t As Integer
  While Not (rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 4)
    t = t + 1
  Wend
  DNALength = t
End Function

' compiles a list of used locations
' (used to introduce gradually new locations
' with mutation, but abandoned)
Public Sub ScanUsedVars(n As Integer)
Dim t As Integer
Dim k As Integer
Dim a As Integer
Dim used As Boolean
used = False
  While Not (rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 4)
    t = t + 1
    If UBound(rob(n).DNA()) < t Then Exit Sub
    If rob(n).DNA(t).tipo = 1 Then
      a = rob(n).DNA(t).value
      For k = 1 To rob(n).maxusedvars
        If rob(n).usedvars(k) = a Then used = True
      Next k
      If Not used Then
        rob(n).maxusedvars = rob(n).maxusedvars + 1
        rob(n).usedvars(rob(n).maxusedvars) = a
      End If
      used = False
    End If
  Wend
End Sub

'
'   L O A D I N G   A N D   P A R S I N G
'

' loads a dna file, inserting the robot in the simulation
Public Function robscriptload(path As String) As Integer
  Dim n As Integer
  n = posto
  preparerob n, path        ' prepares structure
  If carica(path, n) Then   ' loads and parses dna
    insertsysvars n         ' count system vars among used vars
    ScanUsedVars n          ' count other used locations
    makecondlist n          ' creates list with genes entry points
    makeoccurrlist n        ' creates the ref* array
    countconditions n       ' counts conditions used (for costs)
    rob(n).DnaLen = DNALength(n)  ' measures dna length
    robscriptload = n    ' returns the index of the created rob
  Else
    rob(n).Exist = False
  End If
End Function

' prepares with some values the struct of a new rob
Private Sub preparerob(t As Integer, path As String)
    Dim col1 As Long, col2 As Long, col3 As Long
    Dim k As Integer
    rob(t).x = Random(50, Form1.ScaleWidth)
    rob(t).Y = Random(50, Form1.ScaleHeight)
    rob(t).ox = 50
    rob(t).oy = 50
    rob(t).aim = Random(0, 628) / 100
    'rob(t).mem(19) = rob(t).aim*200
    rob(t).aimx = Cos(rob(t).aim)
    rob(t).aimy = Sin(rob(t).aim)
    col1 = Random(50, 255)
    col2 = Random(50, 255)
    col3 = Random(50, 255)
    rob(t).color = col1 * 65536 + col2 * 256 + col3
    rob(t).Exist = True
    rob(t).vx = 1
    rob(t).vx = 0
    rob(t).vnum = 1
    rob(t).pntr = 1
    rob(t).st.pos = 1
    rob(t).nrg = 20000
    rob(t).Veg = False
    k = 1
    While InStr(k, path, "\") > 0
      k = k + 1
    Wend
    rob(t).fname = right$(path, Len(path) - k + 1)
End Sub

' loads the dna and parses it
Private Function carica(path As String, n As Integer) As Boolean
  On Error GoTo fine:
  Dim a As String
  Dim b As String
  Dim pos As Integer
  Dim hold As String
inizio:
  Open path For Input As #1
  While Not EOF(1)
    Line Input #1, a
    
    'eliminate comments from this line for reading
    a = a + " '"
    pos = InStr(a, "'")
    a = left(a, pos - 1)
    While left(a, 0) = " "
      a = right(a, Len(a) - 1)
    Wend
        
    If right(a, 2) = vbCrLf Then a = left(a, Len(a) - 2)
    hold = hold + a
    a = Trim(a)
       
    If (left(a, 1) <> "'" And left(a, 1) <> "/") And a <> "" Then
        If left(a, 3) = "shp" Or left(a, 3) = "def" Then
          If left(a, 3) = "shp" Then  'inserts robot shape
            rob(n).shape = val(right(a, 1))
          End If
          If left(a, 3) = "def" Then  'inserts user defined labels as sysvars
            insertvar n, a
          End If
        Else
          pos = InStr(a, " ")
          While pos <> 0
            b = left(a, pos - 1)
            a = right(a, Len(a) - pos)
            
            While left(a, 0) = " "
              a = right(a, Len(a) - 1)
            Wend
            pos = InStr(a, " ")
            
            If b <> "" Then parse n, b
          Wend
         If a <> "" Then parse n, a
        End If
    Else
      If left(a, 2) = "'#" Or left(a, 2) = "/#" Then
        ' embryo of a new feature, should allow recording
        ' in dna files info such robot colour, generation,
        ' mutations etc
        getvals n, a, hold
      End If
    End If
here:
  Wend
  Close 1
  carica = True
  Exit Function
fine:
  pos = Err.Number
  If Err.Number = 53 Then
    Form1.CommonDialog1.DialogTitle = WScannotfind + path
    Form1.CommonDialog1.ShowOpen
    path = Form1.CommonDialog1.filename
    GoTo inizio
  Else
    Close 1
    MsgBox path + MBnovalidrob
    carica = False
  End If
End Function

' loads the dna and parses it
Private Function carica1(path As String, n As Integer) As Boolean
'  On Error GoTo fine:
'  Dim a As String
'  Dim b As String
'  Dim pos As Integer
'inizio:
'  Open path For Input As #1
'  While Not EOF(1)
'    Line Input #1, a
'    a = Trim(a)
'    If (Left(a, 1) <> "'" And Left(a, 1) <> "/") And a <> "" Then
'      If Left(a, 1) = "#" Then
'        getvals n, a
'      Else
'        If Left(a, 3) = "def" Then
'          insertvar n, a
'        Else
'          pos = InStr(a, " ")
'          While pos <> 0
'            b = Left(a, pos - 1)
'            a = Right(a, Len(a) - pos)
'            pos = InStr(a, " ")
'            parse n, b
'          Wend
'          parse n, a
'        End If
'      End If
'    End If
'  Wend
'  Close 1
'  carica = True
'  Exit Function
'fine:
'  If Err.Number = 53 Then
'    CommonDialog1.DialogTitle = WScannotfind + path
'    CommonDialog1.ShowOpen
'    path = CommonDialog1.FileName
'    GoTo inizio
'  Else
'    Close 1
'    MsgBox path + MBnovalidrob
'    carica = False
'  End If
End Function

' embryo of a new feature, should allow recording
' in dna files info such robot colour, generation, mutations etc
Private Sub getvals(n As Integer, ByVal a As String, hold As String)
  Dim r As Integer
  Dim g As Integer
  Dim b As Integer
  
  Static fname As String
  Static generation As Long
  Static Mutations As Long
  
  a = right$(a, Len(a) - 2)
  If left$(a, 5) = "name:" Then
    a = mid(a, 7)
    fname = a
    rob(n).fname = fname
  End If
  If left$(a, 11) = "generation:" Then
    a = right$(a, Len(a) - 11)
    generation = val(a)
  End If

  If left$(a, 10) = "mutations:" Then
    a = right$(a, Len(a) - 10)
    Mutations = val(a)
  End If
  If left$(a, 5) = "hash:" Then
    hold = left(hold, InStr(hold, "'#hash:") - 1)
    If Hash(hold, 20) = right(a, Len(a) - 6) Then
      rob(n).fname = fname
      rob(n).generation = generation
      rob(n).Mutations = Mutations
    Else
      MsgBox fname + "'s dna hashing incorrect - ignoring parameters", vbExclamation
    End If
  End If
  'If Left$(a, 6) = "color:" Then
  '  'additem function was changed to not apply a random color if a color exists for it already
  '  'bot knows what color it is or wants to be
  '  a = Right$(a, Len(a) - 6)
  '  rob(n).color = Hex(a)
  'End If
End Sub


' embryo of a new feature, should allow recording
' in dna files info such robot colour, generation, mutations etc
Private Sub getvals1(n As Integer, ByVal a As String)
  a = right$(a, Len(a) - 1)
  If left$(a, 5) = "color" Then
    a = right$(a, Len(a) - 6)
    rob(n).color = val(a)
  End If
End Sub

' saves a robot's header informations; can be padded with any
' other information, such as color, base energy, etc.
Public Sub SaveRobHeader(n As Integer, f As Integer, hold As String)
  PrintH 1, "'#name: " + rob(n).fname, hold
  PrintH 1, "'#generation: " + CStr(rob(n).generation), hold
  PrintH 1, "'#mutations: " + CStr(rob(n).Mutations), hold
End Sub

' prints to file saving the printed string, for calculating
' the hash function later
Public Sub PrintH(fn As Byte, s As String, hold As String)
  Print #fn, s

  hold = hold + s
End Sub
' calculates the hash function, i.e. simply a string of length f
' which is unlikely to be generated by a different input s
Public Function Hash(s As String, f As Integer) As String

  Dim buf(100) As Long
  Dim k As Integer
  Hash = ""
  For k = 0 To f
    buf(k) = 0
  Next k
  For k = 1 To Len(s)
    buf(k Mod f) = buf(k Mod f) + Asc(mid(s, k, 1))
    buf(k Mod f) = buf(k Mod f) + buf((k - 1) Mod f)
    buf(k Mod f) = buf(k Mod f) Mod 100
  Next k
  For k = 0 To f - 1
    Hash = Hash + Chr(buf(k) Mod 93 + 33)

  Next k
End Function

' parses dna code, tokenizing instructions in the block
' structure
' types:
' 0 = immediate value
' 1 = pointer
' 2 = instruction
' 3 = condition
' 4 = flow control (cond - start - stop - end)
' 5 = logical operators (and - or - xor - not)
Public Sub parse(n As Integer, a As String)
  Dim tipo As Integer
  Dim ind As Integer
  tipo = 0
  Select Case a
    Case "store"
      tipo = 2
      ind = 1
    Case "add"
      tipo = 2
      ind = 3
    Case "sub"
      tipo = 2
      ind = 4
    Case "mult"
      tipo = 2
      ind = 5
    Case "div"
      tipo = 2
      ind = 6
    Case "rnd"
      tipo = 2
      ind = 7
    Case "inc"
      tipo = 2
      ind = 8
    Case "dec"
      tipo = 2
      ind = 9
    Case "angle"
      tipo = 2
      ind = 10
    Case "dist"
      tipo = 2
      ind = 11
    Case "addstore"
        tipo = 2
        ind = 12
    Case "substore"
        tipo = 2
        ind = 13
    Case "divstore"
        tipo = 2
        ind = 14
    Case "multstore"
        tipo = 2
        ind = 15
    Case "mod"
        tipo = 2
        ind = 16
    Case "ceil"
        tipo = 2
        ind = 17
    Case "floor"
        tipo = 2
        ind = 18
    Case "sqr"
        tipo = 2
        ind = 19
    Case "^"
        tipo = 2
        ind = 20
    Case "sgn"
        tipo = 2
        ind = 21
    Case "abs"
        tipo = 2
        ind = 22
    Case "dup"
        tipo = 2
        ind = 23
    Case "pyth"
        tipo = 2
        ind = 24
    Case "<"
      tipo = 3
      ind = 1
    Case "!>="
      tipo = 3
      ind = 1
    Case ">"
      tipo = 3
      ind = 2
    Case "!<="
      tipo = 3
      ind = 2
    Case "="
      tipo = 3
      ind = 3
    Case "!="
      tipo = 3
      ind = 4
    Case "%="
      tipo = 3
      ind = 5
    Case "!%="
      tipo = 3
      ind = 6
    Case "~="
      tipo = 3
      ind = 7
    Case "!~="
      tipo = 3
      ind = 8
    Case ">="
      tipo = 3
      ind = 9
    Case "!<"
      tipo = 3
      ind = 9
    Case "<="
      tipo = 3
      ind = 10
    Case "!>"
      tipo = 3
      ind = 10
    Case "cond"
      tipo = 4
      ind = 1
    Case "start"
      tipo = 4
      ind = 2
    Case "stop"
      tipo = 4
      ind = 3
    Case "end"
      tipo = 4
      ind = 4
    Case "and"
      tipo = 5
      ind = 1
    Case "or"
      tipo = 5
      ind = 2
    Case "xor"
      tipo = 5
      ind = 3
    Case "not"
      tipo = 5
      ind = 4
  End Select
  If tipo = 0 Then
    If left(a, 1) = "." Then
      ind = variabile(n, a)
    Else
      If left(a, 1) = "*" Then
        tipo = 1
        a = right(a, Len(a) - 1)
        ind = variabile(n, a)
      Else
        tipo = 0
        ind = val(a)
      End If
    End If
  End If
   
  If IsRobDNABounded(rob(n).DNA) = False Then ReDim rob(n).DNA(100)
  If rob(n).pntr > UBound(rob(n).DNA) Then
    ReDim Preserve rob(n).DNA(rob(n).pntr + 1)
    rob(n).DnaLen = rob(n).pntr + 1
  End If
  
  rob(n).DNA(rob(n).pntr).tipo = tipo
  rob(n).DNA(rob(n).pntr).value = ind
  rob(n).pntr = rob(n).pntr + 1
End Sub

' parses variables. If string starts with a dot is a variable
' Searches for variable names in both sysvar and rob.vars
' (robot private variables)
Public Function variabile(n As Integer, a As String)
  Dim msysvar As Integer, mrobvar As Integer, t As Integer
  msysvar = UBound(sysvar)
  mrobvar = UBound(rob(n).vars)
  If left(a, 1) = "." Then
    a = right(a, Len(a) - 1)
    For t = 1 To msysvar
      If sysvar(t).Name = a Then variabile = sysvar(t).value
    Next t
    For t = 1 To mrobvar
      If rob(n).vars(t).Name = a Then variabile = rob(n).vars(t).value
    Next t
  Else
    variabile = val(a)
  End If
End Function

' inserts a new private variable in the private vars list
Public Sub insertvar(n As Integer, a As String)
  Dim b As String
  Dim c As String
  Dim pos As Integer
  a = right(a, Len(a) - 4)
  pos = InStr(a, " ")
  b = left(a, pos - 1)
  c = right(a, Len(a) - pos)
  rob(n).vars(rob(n).vnum).Name = b
  rob(n).vars(rob(n).vnum).value = val(c)
  rob(n).vnum = rob(n).vnum + 1
End Sub

' loads the sysvars.txt file
Public Sub LoadSysVars()
  On Error GoTo aiuto
  Dim a As String
  Dim b As String
  Dim t As Integer
  Dim path As String
  Dim k As Integer
  Dim ok As Integer
  path = MDIForm1.MainDir + "\sysvars2.21.txt"
carica:
  t = 1
  Open path For Input As #1
  While Not EOF(1)
    Input #1, a
    Input #1, b
    sysvar(t).Name = a
    sysvar(t).value = val(b)
    t = t + 1
  Wend
  Close #1
  Exit Sub
aiuto:
  Close 1
  MsgBox MBcannotfindV, , MBwarning
  Form1.CommonDialog1.DialogTitle = "sysvars2.21.txt"
  Form1.CommonDialog1.ShowOpen
  path = Form1.CommonDialog1.filename
  If path <> "" Then
    k = 1
    While InStr(k, path, "\") > 0
      ok = k
      k = InStr(k, path, "\") + 1
    Wend
    MDIForm1.MainDir = left(path, k - 2)
    GoTo carica
  End If
End Sub

' inserts sysvars among used vars
Public Sub insertsysvars(n As Integer)
  Dim t As Integer
  t = 1
  While sysvar(t).Name <> ""
    rob(n).usedvars(t) = sysvar(t).value
    t = t + 1
  Wend
  rob(n).maxusedvars = t - 1
End Sub


' DNA Execution
' D N A    E X E C U T I O N
'

' root of the dna execution part
' takes each robot and passes it to the interpreter
' with some variations for console debug and genes activation
Public Sub execrobs()
  Dim t As Integer
  For t = 1 To MaxRobs
    rob(t).pntr = 1
    If rob(t).Exist Then
    If Not rob(t).Wall And Not rob(t).Corpse And rob(t).DNA(1).tipo = 4 Then
      If Not (rob(t).console Is Nothing) Then
        rob(t).console.textout ""
        rob(t).console.textout "robot genes execution: - =not executed"
        eseguidebug t
      Else
        If t = robfocus Then
          If ActivForm.Visible Then
            exechighlight t
          Else
            eseguirob2 t
          End If
        Else
          eseguirob2 t
        End If
        'eseguirobot rob(t), 0, eyestart, eyeend
      End If
    End If
    End If
    erasesenses t
  Next t
End Sub

' executes program of robot n with genes activation display on
Public Sub exechighlight(n As Integer)
  Dim ga() As Boolean
  Dim k As Integer
  ReDim ga(rob(n).genenum)
  k = 1
  ' scans the list of genes entry points
  ' verifying conditions and jumping to body execution
  While rob(n).condlist(k) > 0
    currgene = k
    If cond(n, rob(n).condlist(k) + 1) Then
      ga(k) = True
      corpo (n)
    Else
      ga(k) = False
    End If
    k = k + 1
  Wend
  ActivForm.DrawGrid ga
End Sub

' executes program of robot n with console opened
Public Sub eseguidebug(n As Integer)
  Dim ga() As Boolean
  Dim k As Integer
  ReDim ga(rob(n).genenum)
  k = 1
  ' scans the list of genes entry points
  ' verifying conditions and jumping to body execution
  ' jay - add a gene name to this to replace CStr(k)
  While rob(n).condlist(k) > 0
    currgene = k
    If cond(n, rob(n).condlist(k) + 1) Then
      rob(n).console.textout CStr(k) & " executed"
      ga(k) = True
      corpo (n)
    Else
      rob(n).console.textout CStr(k) & " -"
      ga(k) = False
    End If
    k = k + 1
  Wend
  If ActivForm.Visible Then ActivForm.DrawGrid ga
End Sub

' plain execution of robot n
Public Sub eseguirob2(n As Integer)
  Dim k As Integer
  k = 1
  ' scans the list of genes entry points
  ' verifying conditions and jumping to body execution
  While rob(n).condlist(k) > 0
    currgene = k
    If cond(n, rob(n).condlist(k) + 1) Then corpo (n)
    k = k + 1
  Wend
End Sub

' verifies conditions:
' pushes values in the stack or evaluates conds
Private Function cond(n As Integer, pnt As Integer) As Boolean
  cond = True
  Dim a As Boolean
  Dim b As Boolean
  
  'clean out the cond list
  Condst.pos = 0
  Condst.val(0) = 0
    
  While rob(n).DNA(pnt).tipo <> 4
    Select Case rob(n).DNA(pnt).tipo
      Case 0, 1
        instack n, pnt
      Case 3
        'cond = cond And comp(n, pnt)
        'changed to place bool onto stack
        writeboolst comp(n, pnt)
      Case 5 'we have a logical operator.  If there aren't enough conditions on the stack, we just do nothing
      Select Case rob(n).DNA(pnt).value
        Case 1 'and
          If Condst.pos >= 2 Then
            a = readboolst()
            b = readboolst()
            writeboolst a And b
          End If
        Case 2 'or
          If Condst.pos >= 2 Then
            a = readboolst
            b = readboolst
            writeboolst a Or b
          End If
        Case 3 'xor
          If Condst.pos >= 2 Then
            a = readboolst
            b = readboolst
            writeboolst a Xor b
          End If
        Case 4 'not
          If Condst.pos >= 1 Then
            a = readboolst
            writeboolst Not a
          End If
      End Select
    End Select
    pnt = pnt + 1
  Wend
  rob(n).pntr = pnt + 1
  While Condst.pos > 0
    cond = cond And readboolst()
  Wend
End Function

'These are for the boolstack conditions
'stack push
Private Sub writeboolst(n As Boolean) 'change to a linked list so there is no stack limit or wasted memory soemtime in the future
  If Condst.pos < 20 Then
    Condst.pos = Condst.pos + 1
    Condst.val(Condst.pos) = n
  End If
End Sub

' stack pop
Private Function readboolst() As Boolean
  readboolst = False 'returns false if there's nothing on the stack
  If Condst.pos > 0 Then
    readboolst = Condst.val(Condst.pos)
    Condst.pos = Condst.pos - 1
  End If
End Function
' body execution:
' pushes values in the stack or jumps to instruction
Private Sub corpo(n As Integer)
  Dim pnt As Integer
 
  rob(n).mem(thisgene) = currgene
  
  For pnt = rob(n).pntr To rob(n).DnaLen
    Select Case rob(n).DNA(pnt).tipo
      Case 0, 1
        instack n, pnt
      Case 2
        istruzione n, pnt
      Case 4
        Exit For
    End Select
  Next pnt
  rob(n).pntr = pnt + 1
  If rob(n).pntr > rob(n).DnaLen - 1 Then rob(n).pntr = rob(n).DnaLen - 1

End Sub

' inserts a value in the stack
' distinguishing immediate values from pointed values
Private Sub instack(n As Integer, pnt As Integer)
  Dim mm As Integer
  mm = rob(n).DNA(pnt).value
  Select Case rob(n).DNA(pnt).tipo
    Case 0
      writest n, mm
    Case 1
      writest n, rob(n).mem(mm)
      ' if a possible reference to an eye location is made
      ' then viewing is activated (once for all):
      ' this saves a lot of time
      If mm >= EyeStart And mm <= EyeEnd Then
          rob(n).view = True
      End If
  End Select
  'End If
End Sub

' stack push
Private Sub writest(n As Integer, val)
  If Abs(val) > 32000 Then val = Sgn(val) * 32000
  If rob(n).st.pos < stacklim Then
    rob(n).st.pos = rob(n).st.pos + 1
    rob(n).st.val(rob(n).st.pos) = val
  End If
End Sub

' stack pop
Private Function readst(n As Integer) As Integer
  readst = 0
  If rob(n).st.pos > 0 Then
    readst = rob(n).st.val(rob(n).st.pos)
    rob(n).st.pos = rob(n).st.pos - 1
  End If
End Function

' parse condition
Private Function comp(n As Integer, pnt As Integer) As Boolean
  comp = True
  Select Case rob(n).DNA(pnt).value
    Case 1
      comp = min(n)
    Case 2
      comp = magg(n)
    Case 3
      comp = equa(n)
    Case 4
      comp = diff(n)
    Case 5
      comp = cequa(n)
    Case 6
      comp = cdiff(n)
    Case 7
       comp = customcequa(n)
    Case 8
       comp = customcdiff(n)
    Case 9
       comp = maggequal(n)
    Case 10
       comp = minequal(n)
  End Select
End Function

' conditions...
Private Function min(n As Integer) As Boolean
  min = (readst(n) > readst(n))
End Function

Private Function magg(n As Integer) As Boolean
  magg = (readst(n) < readst(n))
End Function

Private Function equa(n As Integer) As Boolean
  equa = (readst(n) = readst(n))
End Function

Private Function diff(n As Integer) As Boolean
  diff = (readst(n) <> readst(n))
End Function

Private Function cequa(n As Integer) As Boolean
  Dim a As Integer
  Dim b As Integer
  Dim c As Integer
  b = readst(n)
  a = readst(n)
  c = a / 10
  cequa = (a - c < b) And (a + c * 1# > b)
End Function

Private Function cdiff(n As Integer) As Boolean
  Dim a As Integer
  Dim b As Integer
  Dim c As Integer
  b = readst(n)
  a = readst(n)
  c = a / 10
  cdiff = Not ((CLng(a) + c > b) And (CLng(a) - c < b))
End Function
Private Function customcequa(n As Integer) As Boolean
'usage: 10 20 30 ~= is are 10 and 20 within 30 percent of each other?
  Dim a As Long
  Dim b As Long
  Dim c As Long
  Dim d As Long
  
  d = readst(n)
  b = readst(n)
  a = readst(n)
  c = a / 100 * d
  customcequa = (a - c <= b) And (a + c * 1# >= b)
End Function

Private Function customcdiff(n As Integer) As Boolean
  Dim a As Integer
  Dim b As Integer
  Dim c As Single
  Dim d As Integer
    
  d = readst(n)
  b = readst(n)
  a = readst(n)
  c = a / 100 * d
  customcdiff = Not ((CLng(a) + c >= b) And (CLng(a) - c <= b))
End Function

Private Function minequal(n As Integer) As Boolean
  minequal = (readst(n) >= readst(n))
End Function

Private Function maggequal(n As Integer) As Boolean
  maggequal = (readst(n) <= readst(n))
End Function

' parse instructions
Private Sub istruzione(n As Integer, pnt As Integer)
  Select Case rob(n).DNA(pnt).value
    Case 1
      store n
    Case 3
      addi n
    Case 4
      sottr n
    Case 5
      mult n
    Case 6
      div n
    Case 7
      rand n
    Case 8
      inc n
    Case 9
      dec n
    Case 10
      findang n
    Case 11
      finddist n
    Case 12
      addstore n
    Case 13
      substore n
    Case 14
      divstore n
    Case 15
      multstore n
    Case 16
      DNAmod n
    Case 17
      Ceil n
    Case 18
      Floor n
    Case 19
      DNASqr n
    Case 20
      DNAPower n
    Case 21
      DNASgn n
    Case 22
      DNAAbs n
    Case 23
      DNADuplicate n
    Case 24
      DNAPyth n
  End Select
End Sub

' instructions:
Private Sub inc(n As Integer)
  Dim a As Integer
  a = readst(n)
  If a > 8 And a < 1001 Then
    If rob(n).mem(a) < 32000 Then
      writest n, rob(n).mem(a) + 1
    Else
      writest n, 32000
    End If
    writest n, a
    store n
  End If
End Sub

Private Sub dec(n As Integer)
  Dim a As Integer
  a = readst(n)
  If a > 8 And a < 1001 Then
    If rob(n).mem(a) > -32000 Then
      writest n, rob(n).mem(a) - 1
    Else
      writest n, -32000
    End If
    writest n, a
    store n
  End If
End Sub

Private Sub rand(n As Integer)
  writest n, Random(0, readst(n))
End Sub
Private Sub findang(n As Integer)
  Dim a As Long  'target xpos
  Dim b As Long  'target ypos
  Dim c As Long  'robot's xpos
  Dim d As Long  'robot's ypos
  Dim e As Long  'angle to target
  b = readst(n)
  a = readst(n)
  c = rob(n).x
  d = rob(n).Y
  e = angnorm(angle(c, d, a, b)) * 200
  writest n, Int(e)
End Sub
Private Sub finddist(n As Integer)
  Dim a As Single  'target xpos
  Dim b As Single  'target ypos
  Dim c As Single  'robot's xpos
  Dim d As Single  'robot's ypos
  Dim e As Single  'distance to target
  b = readst(n)
  a = readst(n)
  c = rob(n).x
  d = rob(n).Y
  e = ((c - a) ^ 2 + (d - b) ^ 2) ^ 0.5
  writest n, Int(e)
End Sub

Private Sub store(n As Integer)
  Dim a As Integer
  Dim b As Integer
  b = readst(n)
  a = readst(n)
  If b > 0 And b < MaxMem Then
    rob(n).nrg = rob(n).nrg - SimOpts.CostStore / (rob(n).Numties + 1)
    rob(n).mem(b) = a
  End If
End Sub

Private Sub addi(n As Integer)
  Dim a As Long
  Dim b As Long
  Dim c As Long
  b = readst(n)
  a = readst(n)
  c = a + b
  If Abs(c) > 32000 Then c = 32000 * Sgn(c)
  writest n, Int(c)
End Sub

Private Sub sottr(n As Integer)
  Dim a As Long
  Dim b As Long
  Dim c As Long
  b = readst(n)
  a = readst(n)
  c = a - b
  If Abs(c) > 32000 Then c = 32000 * Sgn(c)
  writest n, c
End Sub

Private Sub mult(n As Integer)
  Dim a As Single
  Dim b As Single
  Dim c As Single
  b = readst(n)
  a = readst(n)
  c = a * b
  If Abs(c) > 32000 Then c = 32000 * Sgn(c)
  writest n, Int(c)
End Sub

Private Sub div(n As Integer)
  Dim a As Integer
  Dim b As Integer
  b = readst(n)
  a = readst(n)
  If b <> 0 Then
    writest n, a / b
  Else
    writest n, 0
  End If
End Sub
'New Math functions, etc. added.  Moved energy cost so nonsense Xstores don't cost any energy
'Good idea  PY
Private Sub addstore(robotnumber As Integer)
    Dim a As Integer
    Dim b As Integer
    b = readst(robotnumber)
    a = readst(robotnumber)
    If b > 0 And b < MaxMem Then
        rob(robotnumber).nrg = rob(robotnumber).nrg - SimOpts.CostStore / (rob(robotnumber).Numties + 1)
        If Abs(rob(robotnumber).mem(b) + a) <= 32000 Then
            rob(robotnumber).mem(b) = rob(robotnumber).mem(b) + a
        Else
            rob(robotnumber).mem(b) = Sgn(rob(robotnumber).mem(b)) * 32000
        End If
    End If
End Sub
'Good idea  PY
Private Sub substore(robotnumber As Integer)
    Dim a As Integer
    Dim b As Integer
    b = readst(robotnumber)
    a = readst(robotnumber)
    If b > 0 And b < MaxMem Then
        rob(robotnumber).nrg = rob(robotnumber).nrg - SimOpts.CostStore / (rob(robotnumber).Numties + 1)
        If Abs(rob(robotnumber).mem(b) - a) <= 32000 Then
            rob(robotnumber).mem(b) = rob(robotnumber).mem(b) - a
        Else
            rob(robotnumber).mem(b) = Sgn(rob(robotnumber).mem(b)) * 32000
        End If
    End If
End Sub
'Good idea  PY
Private Sub multstore(robotnumber As Integer)
    Dim a As Single
    Dim b As Integer
    Dim c As Single
                
    b = readst(robotnumber)
    a = readst(robotnumber)
    
    If b > 0 And b < MaxMem Then
        c = a * rob(robotnumber).mem(b)
        If Abs(c) > 32000 Then c = 32000 * Sgn(c)
        rob(robotnumber).nrg = rob(robotnumber).nrg - SimOpts.CostStore / (rob(robotnumber).Numties + 1)
        rob(robotnumber).mem(b) = Int(c)
    End If
End Sub

'Good idea  PY
Private Sub divstore(robotnumber As Integer) 'Will return 0 if dividing by zero
    Dim a As Integer
    Dim b As Integer
    b = readst(robotnumber)
    a = readst(robotnumber)
    If b > 0 And b < MaxMem And a <> 0 Then
        rob(robotnumber).nrg = rob(robotnumber).nrg - SimOpts.CostStore / (rob(robotnumber).Numties + 1)
        If a <> 0 Then
            rob(robotnumber).mem(b) = rob(robotnumber).mem(b) / a
        Else
            rob(robotnumber).mem(b) = 0
        End If
    End If
End Sub
'applies a ceiling to a value on the stack.
'Usage: val ceilingvalue ceil.
Private Sub Ceil(robotnumber As Integer)
  Dim a As Integer
  Dim b As Integer

  b = readst(robotnumber)
  a = readst(robotnumber)

  If a > b Then
    writest robotnumber, b
  Else
    writest robotnumber, a
  End If
End Sub

'similar to ceil but with a floor instead
Private Sub Floor(robotnumber As Integer)
  Dim a As Integer
  Dim b As Integer

  b = readst(robotnumber)
  a = readst(robotnumber)

  If a < b Then
    writest robotnumber, b
  Else
    writest robotnumber, a
  End If
End Sub

Private Sub DNAmod(robotnumber As Integer)
  Dim a As Integer
  Dim b As Integer
  
  b = readst(robotnumber)
  a = readst(robotnumber)
  
  If b = 0 Then
    writest robotnumber, a
  Else
    writest robotnumber, a Mod b
  End If
End Sub

'Returns square root of a positive number. Can't think of a specific use but it is valid.
Private Sub DNASqr(robotnumber As Integer) 'returns a rounded value
    Dim a As Single
    a = readst(robotnumber)
    
    If a >= 0 Then 'Don't squareroot a negative number!!  Returns 0 if negative
        writest robotnumber, Sqr(a)
    Else
        writest robotnumber, 0
    End If
End Sub

'returns a power number. Raises a (top number) to the power of b (second number)
'Seems kind of pointless to me
Private Sub DNAPower(robotnumber As Integer) ' Could still be crashy with odd values, need to _really_ test it
    Dim a As Single
    Dim b As Single
    Dim c As Single
    b = readst(robotnumber)
    a = readst(robotnumber)
    
    If a = 1 Or b = 1 Then
        writest robotnumber, a
    ElseIf b < 0 And Abs(a) <> 1 Then
        writest robotnumber, 0
    ElseIf a = -1 Then
        writest robotnumber, Int(a ^ b)
    ElseIf Abs(a) <= 178 And Abs(a) <> 1 And b <= 14 And b >= 0 Then
        c = a ^ b
        If c <= 32000 Then
            writest robotnumber, Int(c)
        Else 'just make it as big as we can, the user is mad anyway
            writest robotnumber, 32000
        End If
    Else
        writest robotnumber, 32000
    End If
End Sub

'This one could be very useful
Private Sub DNASgn(robotnumber As Integer) 'returns sign of number on stack
    Dim a As Integer
    a = readst(robotnumber)
    
    writest robotnumber, Sgn(a)
End Sub

'So could this
Private Sub DNAAbs(robotnumber As Integer) 'returns absolute value of number on stack
    Dim a As Integer
    a = readst(robotnumber)
    
    writest robotnumber, Abs(a)
End Sub

'And this
Private Sub DNADuplicate(robotnumber As Integer) 'places a duplicate copy of the top value on the stack
    Dim a As Integer
    a = readst(robotnumber)
    writest robotnumber, a
    writest robotnumber, a
End Sub

'Works out the length of the hypoteneuse in a right angle triangle.
'Completely pointless as dist already does this.
'Requires two lengths to be calculated and stored in the stack first.
'Also could crash if a or b get very big
Private Sub DNAPyth(robotnumber As Integer) 'places a duplicate copy of the top value on the stack
    Dim a As Single
    Dim b As Single
    Dim c As Single
        
    b = readst(robotnumber)
    a = readst(robotnumber)
    
    c = Sqr(b ^ 2 + a ^ 2)
    
    If c < 32000 Then
        writest robotnumber, Int(c)
    Else
        writest robotnumber, 32000 ' or should we return something else?
    End If
End Sub

' another function for detokenizing dna
' (there's a third one in DnaOps)
Public Function StringDNA(n As Integer) As String
  Dim t As Integer
  Dim a As String
  Dim gn As Integer
  Dim va As Integer, ti As Byte
  Dim d As String
  d = ""
  t = 1
  gn = 1
  While Not (rob(n).DNA(t).tipo = 4 And rob(n).DNA(t).value = 4)
    ti = rob(n).DNA(t).tipo
    va = rob(n).DNA(t).value
    Select Case rob(n).DNA(t).tipo
      Case 0
        If rob(n).DNA(t + 1).tipo = 2 And rob(n).DNA(t + 1).value = 1 Then
          d = d + "  " + varname(va)
        Else
          d = d + " " + Str$(va)
        End If
      Case 1
        a = varname(va)
        d = d + "  " + "*" + a
      Case 2
        Select Case va
          Case 1
            d = d + "  store"
          Case 3
            d = d + "  add"
          Case 4
            d = d + "  sub"
          Case 5
            d = d + "  mult"
          Case 6
            d = d + "  div"
          Case 7
            d = d + "  rnd"
          Case 8
            d = d + "  inc"
          Case 9
            d = d + "  dec"
          Case 10
            d = d + "  angle"
          Case 11
            d = d + "  dist"
          Case 12
            d = d + "  addstore"
          Case 13
            d = d + "  substore"
          Case 14
            d = d + "  divstore"
          Case 15
            d = d + "  multstore"
          Case 16
            d = d + "  mod"
          Case 17
            d = d + "  ceil"
          Case 18
            d = d + "  floor"
          Case 19
            d = d + "  sqr"
          Case 20
            d = d + "  ^"
          Case 21
            d = d + "  sgn"
          Case 22
            d = d + "  abs"
          Case 23
            d = d + "  dup"
          Case 24
            d = d + "  pyth"
        End Select
      Case 3
        Select Case va
          Case 1
            d = d + "  <"
          Case 2
            d = d + "  >"
          Case 3
            d = d + "  ="
          Case 4
            d = d + "  !="
          Case 5
            d = d + "  %="
          Case 6
            d = d + "  !%="
          Case 7
            d = d + "  ~="
          Case 8
            d = d + "  !~="
          Case 9
            d = d + "  >="
          Case 10
            d = d + "  <="
        End Select
      Case 4
        Select Case va
          Case 1
            d = d + ""
            d = d + "cond"
          Case 2
            d = d + "start"
          Case 3
            gn = gn + 1
            d = d + "stop" + vbCrLf + "--------------" + Str(gn)
          Case 4
            d = d + "end"
        End Select
      Case 5
        Select Case va
          Case 1
            d = d + " and"
          Case 2
            d = d + " or"
          Case 3
            d = d + " xor"
          Case 4
            d = d + " not"
        End Select
      End Select
      d = d + vbCrLf
    t = t + 1
  Wend
  d = d + "end"
  StringDNA = d
End Function

Function IsRobDNABounded(ByRef ArrayIn() As block) As Boolean
  On Error Resume Next
  IsRobDNABounded = False
  IsRobDNABounded = (UBound(ArrayIn) >= LBound(ArrayIn))
End Function
